from AutoRPE.UtilsRPE.CodeTools import change_code


def get_command_line_arguments():
    from optparse import OptionParser
    from os.path import isfile, isdir
    # Parse and assert command line options
    parser = OptionParser()
    parser.add_option("-l", "--variable-list", dest="variable_list",
                      help="Path to the filename with the list of variables.", default=None, metavar="FILE")
    parser.add_option("-p", "--precision", dest="precision",
                      help="Precision specification at which the variables in the list will be set", default="dp")

    parser.add_option("-s", "--source", dest="source_path",
                      help="Path to the source that will be modified.", default=None)
    parser.add_option("-v", "--vault", dest="vault_path",
                      help="Path to the vault.", default=None, metavar="FILE")

    (options, args) = parser.parse_args()

    list_filename = options.variable_list
    source_path = options.source_path
    vault_path = options.vault_path
    precision = options.precision
    try:
        assert list_filename is not None, "Argument -l/--variable-list required!"
        assert source_path is not None, "Argument -s/--source required!"
        assert vault_path is not None, "Argument -v/--vault required!"
        assert isfile(list_filename), "Argument -l/--variable-list %s is not a file." % list_filename
        assert isdir(source_path), "Argument -s/--source  %s is not a valid directory." % source_path
        assert isfile(vault_path), "Argument -v/--vault %s is not a file." % vault_path
    except AssertionError as error:
        parser.print_help()
        print("\n\n")
        print(error)
        exit(1)

    return list_filename, source_path, vault_path, precision


list_filename, source_path, vault_path, precision = get_command_line_arguments()

change_code(list_filename, source_path, vault_path, precision)
